// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// GetPaymentFormRequest represents TL type `getPaymentForm#96e6319`.
type GetPaymentFormRequest struct {
	// Chat identifier of the Invoice message
	ChatID int64
	// Message identifier
	MessageID int64
	// Preferred payment form theme; pass null to use the default theme
	Theme PaymentFormTheme
}

// GetPaymentFormRequestTypeID is TL type id of GetPaymentFormRequest.
const GetPaymentFormRequestTypeID = 0x96e6319

// Ensuring interfaces in compile-time for GetPaymentFormRequest.
var (
	_ bin.Encoder     = &GetPaymentFormRequest{}
	_ bin.Decoder     = &GetPaymentFormRequest{}
	_ bin.BareEncoder = &GetPaymentFormRequest{}
	_ bin.BareDecoder = &GetPaymentFormRequest{}
)

func (g *GetPaymentFormRequest) Zero() bool {
	if g == nil {
		return true
	}
	if !(g.ChatID == 0) {
		return false
	}
	if !(g.MessageID == 0) {
		return false
	}
	if !(g.Theme.Zero()) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (g *GetPaymentFormRequest) String() string {
	if g == nil {
		return "GetPaymentFormRequest(nil)"
	}
	type Alias GetPaymentFormRequest
	return fmt.Sprintf("GetPaymentFormRequest%+v", Alias(*g))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*GetPaymentFormRequest) TypeID() uint32 {
	return GetPaymentFormRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*GetPaymentFormRequest) TypeName() string {
	return "getPaymentForm"
}

// TypeInfo returns info about TL type.
func (g *GetPaymentFormRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "getPaymentForm",
		ID:   GetPaymentFormRequestTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "ChatID",
			SchemaName: "chat_id",
		},
		{
			Name:       "MessageID",
			SchemaName: "message_id",
		},
		{
			Name:       "Theme",
			SchemaName: "theme",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (g *GetPaymentFormRequest) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getPaymentForm#96e6319 as nil")
	}
	b.PutID(GetPaymentFormRequestTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *GetPaymentFormRequest) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode getPaymentForm#96e6319 as nil")
	}
	b.PutInt53(g.ChatID)
	b.PutInt53(g.MessageID)
	if err := g.Theme.Encode(b); err != nil {
		return fmt.Errorf("unable to encode getPaymentForm#96e6319: field theme: %w", err)
	}
	return nil
}

// Decode implements bin.Decoder.
func (g *GetPaymentFormRequest) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getPaymentForm#96e6319 to nil")
	}
	if err := b.ConsumeID(GetPaymentFormRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode getPaymentForm#96e6319: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *GetPaymentFormRequest) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode getPaymentForm#96e6319 to nil")
	}
	{
		value, err := b.Int53()
		if err != nil {
			return fmt.Errorf("unable to decode getPaymentForm#96e6319: field chat_id: %w", err)
		}
		g.ChatID = value
	}
	{
		value, err := b.Int53()
		if err != nil {
			return fmt.Errorf("unable to decode getPaymentForm#96e6319: field message_id: %w", err)
		}
		g.MessageID = value
	}
	{
		if err := g.Theme.Decode(b); err != nil {
			return fmt.Errorf("unable to decode getPaymentForm#96e6319: field theme: %w", err)
		}
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (g *GetPaymentFormRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if g == nil {
		return fmt.Errorf("can't encode getPaymentForm#96e6319 as nil")
	}
	b.ObjStart()
	b.PutID("getPaymentForm")
	b.Comma()
	b.FieldStart("chat_id")
	b.PutInt53(g.ChatID)
	b.Comma()
	b.FieldStart("message_id")
	b.PutInt53(g.MessageID)
	b.Comma()
	b.FieldStart("theme")
	if err := g.Theme.EncodeTDLibJSON(b); err != nil {
		return fmt.Errorf("unable to encode getPaymentForm#96e6319: field theme: %w", err)
	}
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (g *GetPaymentFormRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if g == nil {
		return fmt.Errorf("can't decode getPaymentForm#96e6319 to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("getPaymentForm"); err != nil {
				return fmt.Errorf("unable to decode getPaymentForm#96e6319: %w", err)
			}
		case "chat_id":
			value, err := b.Int53()
			if err != nil {
				return fmt.Errorf("unable to decode getPaymentForm#96e6319: field chat_id: %w", err)
			}
			g.ChatID = value
		case "message_id":
			value, err := b.Int53()
			if err != nil {
				return fmt.Errorf("unable to decode getPaymentForm#96e6319: field message_id: %w", err)
			}
			g.MessageID = value
		case "theme":
			if err := g.Theme.DecodeTDLibJSON(b); err != nil {
				return fmt.Errorf("unable to decode getPaymentForm#96e6319: field theme: %w", err)
			}
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetChatID returns value of ChatID field.
func (g *GetPaymentFormRequest) GetChatID() (value int64) {
	if g == nil {
		return
	}
	return g.ChatID
}

// GetMessageID returns value of MessageID field.
func (g *GetPaymentFormRequest) GetMessageID() (value int64) {
	if g == nil {
		return
	}
	return g.MessageID
}

// GetTheme returns value of Theme field.
func (g *GetPaymentFormRequest) GetTheme() (value PaymentFormTheme) {
	if g == nil {
		return
	}
	return g.Theme
}

// GetPaymentForm invokes method getPaymentForm#96e6319 returning error if any.
func (c *Client) GetPaymentForm(ctx context.Context, request *GetPaymentFormRequest) (*PaymentForm, error) {
	var result PaymentForm

	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return &result, nil
}
