// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// ResendMessagesRequest represents TL type `resendMessages#60d350b8`.
type ResendMessagesRequest struct {
	// Identifier of the chat to send messages
	ChatID int64
	// Identifiers of the messages to resend. Message identifiers must be in a strictly
	// increasing order
	MessageIDs []int64
}

// ResendMessagesRequestTypeID is TL type id of ResendMessagesRequest.
const ResendMessagesRequestTypeID = 0x60d350b8

// Ensuring interfaces in compile-time for ResendMessagesRequest.
var (
	_ bin.Encoder     = &ResendMessagesRequest{}
	_ bin.Decoder     = &ResendMessagesRequest{}
	_ bin.BareEncoder = &ResendMessagesRequest{}
	_ bin.BareDecoder = &ResendMessagesRequest{}
)

func (r *ResendMessagesRequest) Zero() bool {
	if r == nil {
		return true
	}
	if !(r.ChatID == 0) {
		return false
	}
	if !(r.MessageIDs == nil) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (r *ResendMessagesRequest) String() string {
	if r == nil {
		return "ResendMessagesRequest(nil)"
	}
	type Alias ResendMessagesRequest
	return fmt.Sprintf("ResendMessagesRequest%+v", Alias(*r))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*ResendMessagesRequest) TypeID() uint32 {
	return ResendMessagesRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*ResendMessagesRequest) TypeName() string {
	return "resendMessages"
}

// TypeInfo returns info about TL type.
func (r *ResendMessagesRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "resendMessages",
		ID:   ResendMessagesRequestTypeID,
	}
	if r == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "ChatID",
			SchemaName: "chat_id",
		},
		{
			Name:       "MessageIDs",
			SchemaName: "message_ids",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (r *ResendMessagesRequest) Encode(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't encode resendMessages#60d350b8 as nil")
	}
	b.PutID(ResendMessagesRequestTypeID)
	return r.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (r *ResendMessagesRequest) EncodeBare(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't encode resendMessages#60d350b8 as nil")
	}
	b.PutInt53(r.ChatID)
	b.PutInt(len(r.MessageIDs))
	for _, v := range r.MessageIDs {
		b.PutInt53(v)
	}
	return nil
}

// Decode implements bin.Decoder.
func (r *ResendMessagesRequest) Decode(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't decode resendMessages#60d350b8 to nil")
	}
	if err := b.ConsumeID(ResendMessagesRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode resendMessages#60d350b8: %w", err)
	}
	return r.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (r *ResendMessagesRequest) DecodeBare(b *bin.Buffer) error {
	if r == nil {
		return fmt.Errorf("can't decode resendMessages#60d350b8 to nil")
	}
	{
		value, err := b.Int53()
		if err != nil {
			return fmt.Errorf("unable to decode resendMessages#60d350b8: field chat_id: %w", err)
		}
		r.ChatID = value
	}
	{
		headerLen, err := b.Int()
		if err != nil {
			return fmt.Errorf("unable to decode resendMessages#60d350b8: field message_ids: %w", err)
		}

		if headerLen > 0 {
			r.MessageIDs = make([]int64, 0, headerLen%bin.PreallocateLimit)
		}
		for idx := 0; idx < headerLen; idx++ {
			value, err := b.Int53()
			if err != nil {
				return fmt.Errorf("unable to decode resendMessages#60d350b8: field message_ids: %w", err)
			}
			r.MessageIDs = append(r.MessageIDs, value)
		}
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (r *ResendMessagesRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if r == nil {
		return fmt.Errorf("can't encode resendMessages#60d350b8 as nil")
	}
	b.ObjStart()
	b.PutID("resendMessages")
	b.Comma()
	b.FieldStart("chat_id")
	b.PutInt53(r.ChatID)
	b.Comma()
	b.FieldStart("message_ids")
	b.ArrStart()
	for _, v := range r.MessageIDs {
		b.PutInt53(v)
		b.Comma()
	}
	b.StripComma()
	b.ArrEnd()
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (r *ResendMessagesRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if r == nil {
		return fmt.Errorf("can't decode resendMessages#60d350b8 to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("resendMessages"); err != nil {
				return fmt.Errorf("unable to decode resendMessages#60d350b8: %w", err)
			}
		case "chat_id":
			value, err := b.Int53()
			if err != nil {
				return fmt.Errorf("unable to decode resendMessages#60d350b8: field chat_id: %w", err)
			}
			r.ChatID = value
		case "message_ids":
			if err := b.Arr(func(b tdjson.Decoder) error {
				value, err := b.Int53()
				if err != nil {
					return fmt.Errorf("unable to decode resendMessages#60d350b8: field message_ids: %w", err)
				}
				r.MessageIDs = append(r.MessageIDs, value)
				return nil
			}); err != nil {
				return fmt.Errorf("unable to decode resendMessages#60d350b8: field message_ids: %w", err)
			}
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetChatID returns value of ChatID field.
func (r *ResendMessagesRequest) GetChatID() (value int64) {
	if r == nil {
		return
	}
	return r.ChatID
}

// GetMessageIDs returns value of MessageIDs field.
func (r *ResendMessagesRequest) GetMessageIDs() (value []int64) {
	if r == nil {
		return
	}
	return r.MessageIDs
}

// ResendMessages invokes method resendMessages#60d350b8 returning error if any.
func (c *Client) ResendMessages(ctx context.Context, request *ResendMessagesRequest) (*Messages, error) {
	var result Messages

	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return nil, err
	}
	return &result, nil
}
