// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// SendChatScreenshotTakenNotificationRequest represents TL type `sendChatScreenshotTakenNotification#1aba0861`.
type SendChatScreenshotTakenNotificationRequest struct {
	// Chat identifier
	ChatID int64
}

// SendChatScreenshotTakenNotificationRequestTypeID is TL type id of SendChatScreenshotTakenNotificationRequest.
const SendChatScreenshotTakenNotificationRequestTypeID = 0x1aba0861

// Ensuring interfaces in compile-time for SendChatScreenshotTakenNotificationRequest.
var (
	_ bin.Encoder     = &SendChatScreenshotTakenNotificationRequest{}
	_ bin.Decoder     = &SendChatScreenshotTakenNotificationRequest{}
	_ bin.BareEncoder = &SendChatScreenshotTakenNotificationRequest{}
	_ bin.BareDecoder = &SendChatScreenshotTakenNotificationRequest{}
)

func (s *SendChatScreenshotTakenNotificationRequest) Zero() bool {
	if s == nil {
		return true
	}
	if !(s.ChatID == 0) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (s *SendChatScreenshotTakenNotificationRequest) String() string {
	if s == nil {
		return "SendChatScreenshotTakenNotificationRequest(nil)"
	}
	type Alias SendChatScreenshotTakenNotificationRequest
	return fmt.Sprintf("SendChatScreenshotTakenNotificationRequest%+v", Alias(*s))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*SendChatScreenshotTakenNotificationRequest) TypeID() uint32 {
	return SendChatScreenshotTakenNotificationRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*SendChatScreenshotTakenNotificationRequest) TypeName() string {
	return "sendChatScreenshotTakenNotification"
}

// TypeInfo returns info about TL type.
func (s *SendChatScreenshotTakenNotificationRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "sendChatScreenshotTakenNotification",
		ID:   SendChatScreenshotTakenNotificationRequestTypeID,
	}
	if s == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "ChatID",
			SchemaName: "chat_id",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (s *SendChatScreenshotTakenNotificationRequest) Encode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode sendChatScreenshotTakenNotification#1aba0861 as nil")
	}
	b.PutID(SendChatScreenshotTakenNotificationRequestTypeID)
	return s.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (s *SendChatScreenshotTakenNotificationRequest) EncodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode sendChatScreenshotTakenNotification#1aba0861 as nil")
	}
	b.PutInt53(s.ChatID)
	return nil
}

// Decode implements bin.Decoder.
func (s *SendChatScreenshotTakenNotificationRequest) Decode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode sendChatScreenshotTakenNotification#1aba0861 to nil")
	}
	if err := b.ConsumeID(SendChatScreenshotTakenNotificationRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode sendChatScreenshotTakenNotification#1aba0861: %w", err)
	}
	return s.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (s *SendChatScreenshotTakenNotificationRequest) DecodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode sendChatScreenshotTakenNotification#1aba0861 to nil")
	}
	{
		value, err := b.Int53()
		if err != nil {
			return fmt.Errorf("unable to decode sendChatScreenshotTakenNotification#1aba0861: field chat_id: %w", err)
		}
		s.ChatID = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (s *SendChatScreenshotTakenNotificationRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if s == nil {
		return fmt.Errorf("can't encode sendChatScreenshotTakenNotification#1aba0861 as nil")
	}
	b.ObjStart()
	b.PutID("sendChatScreenshotTakenNotification")
	b.Comma()
	b.FieldStart("chat_id")
	b.PutInt53(s.ChatID)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (s *SendChatScreenshotTakenNotificationRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if s == nil {
		return fmt.Errorf("can't decode sendChatScreenshotTakenNotification#1aba0861 to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("sendChatScreenshotTakenNotification"); err != nil {
				return fmt.Errorf("unable to decode sendChatScreenshotTakenNotification#1aba0861: %w", err)
			}
		case "chat_id":
			value, err := b.Int53()
			if err != nil {
				return fmt.Errorf("unable to decode sendChatScreenshotTakenNotification#1aba0861: field chat_id: %w", err)
			}
			s.ChatID = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetChatID returns value of ChatID field.
func (s *SendChatScreenshotTakenNotificationRequest) GetChatID() (value int64) {
	if s == nil {
		return
	}
	return s.ChatID
}

// SendChatScreenshotTakenNotification invokes method sendChatScreenshotTakenNotification#1aba0861 returning error if any.
func (c *Client) SendChatScreenshotTakenNotification(ctx context.Context, chatid int64) error {
	var ok Ok

	request := &SendChatScreenshotTakenNotificationRequest{
		ChatID: chatid,
	}
	if err := c.rpc.Invoke(ctx, request, &ok); err != nil {
		return err
	}
	return nil
}
